unit MSG;

{ .MSG unit version 1.0 (c) by WiZARD//RPC (Sergey Korowkin), 1997.}
{ 2:5031/27 183:5031/9 911:1959/1 }

interface
uses Objects, TpDos, TpString, Strings;

const
  mflPrivate = $0001; { +Pvt - 筮                            }
  mflCrash   = $0002; { +Cra - ᮪ਮ⭮                }
  mflRead    = $0004; {  Rec - ⠭ ⥫             }
  mflSent    = $0008; {  Snt - ᫠                           }
  mflFile    = $0010; { +Att -                           }
  mflTransit = $0020; {  Trs - ࠭⭮                        }
  mflOrphan  = $0040; {  Orp - ⥫            }
  mflKill    = $0080; {  K/s -  ᫥ 뫪             }
  mflLocal   = $0100; {  Loc -    㧫            }
  mflHold    = $0200; {  Hld - 뫪  室饬        }
  mflFReq    = $0800; {  FRq -  䠩                      }
  mflRReq    = $1000; { +RRq -  ⢥ত ਥ       }
  mflISRR    = $2000; { +RRc - ⢥ত ਥ              }
  mflAReq    = $4000; { +ARq - Audit request ???                 }
  mflFUpsReq = $8000; {  URq -   䠩           }

 klINTL      = #1'INTL ';  {#INTL toaddrNOPT fromaddrNOPT }
 klTOPT      = #1'TOPT ';  {#TOPT * }
 klFMPT      = #1'FMPT ';  {#FMPT * }
 klMSGID     = #1'MSGID: '; {#MSGID fromaddress unique_num }
 klPID       = #1'PID: ';   {#PID programm }

type
 PMsgHeader  = ^TMsgHeader;
 TMsgHeader  = record
  FromUser   : array[1..36] of char; {  ࠢ⥫ From: }
  ToUser     : array[1..36] of char; {  ⥫ To: }
  Subject    : array[1..72] of char; {  Subj: }
  Date       : array[1..20] of char; { 쭠  ᮧ [dd mmm yy hh:mm:ss] }
  TimesRead  : word;                 { Number of times message read }
  DestNode   : word;                 { H  ⥫ To: }
  OrigNode   : word;                 { H  ࠢ⥫ From: }
  Cost       : word;                 { ⮨ 뫪 쬠 }
  OrigNet    : word;                 { H  ࠢ⥫ From:}
  DestNet    : word;                 { H  ⥫ To: }
  DateWritten: longint;              {  ᮧ (DOS ଠ) }
  DateArrived: longint;              {  ਥ/뫪 (DOS ଠ) }
  ReplyTo    : word;                 { ⥫  ।饥 쬮 }
  Attr       : word;                 { ᪠ ਡ⮢ }
  ReplyNext  : word;                 { ⥫  ᫥饥 쬮 }
 end;

 PMessage       = ^TMessage;
 TMessage       = object(TObject)
  header        : TMsgHeader;        {  ᮮe }
  fmpt          : word;              {  FroMPoinT }
  topt          : word;              {  TOPoinT }
  intl          : string[40];        {  INTL }
  msgid         : string[40];        {  MSGID (pe) }
  pid           : string[40];        {  PID }
  message       : pointer;           { e  ep ᮮe }
  messagesize   : word;              { ep ᮮe }

  constructor   Init;

  function      GetSourceAddress: string;
  function      GetDestinationAddress: string;
  function      GetSourceName: string;
  function      GetDestinationName: string;
  function      GetDate: string;
  function      GetSubject: string;
  function      GetFlags: word;
  function      GetFlag(flag: word): boolean;
  procedure     SetSourceAddress(s: string);
  procedure     SetDestinationAddress(s: string);
  procedure     SetSourceName(s: string);
  procedure     SetDestinationName(s: string);
  procedure     SetDate(s: string);
  procedure     SetSubject(s: string);
  procedure     SetFlags(flags: word);
  procedure     SetFlag(flag: word; enable: boolean);
  procedure     LoadMsg(fn: string);
  procedure     SaveMsg(fn: string);

  destructor    Done; virtual;
 end;

implementation

constructor TMessage.Init;
 begin
  inherited Init;
  message:=nil;
  messagesize:=0;
 end;

function TMessage.GetSourceAddress;
 begin
  GetSourceAddress:=ExtractWord(1,INTL,[':'])+':'+
                    Long2Str(Header.OrigNet)+'/'+
                    Long2Str(Header.OrigNode)+'.'+
                    Long2Str(FmPt);;
 end;

function TMessage.GetDestinationAddress;
 begin
  GetDestinationAddress:=ExtractWord(1,INTL,[':'])+':'+
                         Long2Str(Header.DestNet)+'/'+
                         Long2Str(Header.DestNode)+'.'+
                         Long2Str(ToPt);;
 end;

function TMessage.GetSourceName;
 begin
  GetSourceName:=StrPas(PChar(@Header.FromUser));
 end;

function TMessage.GetDestinationName;
 begin
  GetDestinationName:=StrPas(PChar(@Header.ToUser));
 end;

function TMessage.GetDate;
 begin
  GetDate:=StrPas(PChar(@Header.Date));
 end;

function TMessage.GetSubject;
 begin
  GetSubject:=StrPas(PChar(@Header.Subject));
 end;

function TMessage.GetFlags;
 begin
  GetFlags:=Header.Attr;
 end;

function TMessage.GetFlag;
 begin
  GetFlag:=GetFlags and flag<>0;
 end;

procedure TMessage.SetSourceAddress;
 begin
  INTL:=ExtractWord(1,INTL,[' '])+' '+S;
  Str2Word(ExtractWord(2,S,[':','/']),Header.OrigNet);
  Str2Word(ExtractWord(3,S,[':','/','.']),Header.OrigNode);
  S:=ExtractWord(4,S,[':','/','.']);
  if S='' then FMPT:=0 else Str2Word(S,FmPt);
 end;

procedure TMessage.SetDestinationAddress;
 begin
  INTL:=S+' '+ExtractWord(2,INTL,[' ']);
  Str2Word(ExtractWord(2,S,[':','/']),Header.DestNet);
  Str2Word(ExtractWord(3,S,[':','/','.']),Header.DestNode);
  S:=ExtractWord(4,S,[':','/','.']);
  if S='' then TOPT:=0 else Str2Word(S,ToPt);
 end;

procedure TMessage.SetSourceName;
 begin
  StrPCopy(PChar(@Header.FromUser),S);
 end;

procedure TMessage.SetDestinationName;
 begin
  StrPCopy(PChar(@Header.ToUser),S);
 end;

procedure TMessage.SetDate;
 begin
  StrPCopy(PChar(@Header.Date),S);
 end;

procedure TMessage.SetSubject;
 begin
  StrPCopy(PChar(@Header.Subject),S);
 end;

procedure TMessage.SetFlags;
 begin
  Header.Attr:=Flags;
 end;

procedure TMessage.SetFlag;
 begin
  if Enable then
   Header.Attr:=Header.Attr or flag
  else
   Header.Attr:=Header.Attr and not flag;
 end;

procedure TMessage.LoadMsg;
 var
  f: file;
  t: text;
  o: text;
  s: string;
 begin
  if message<>nil then freemem(message,messagesize);

  fillchar(header,sizeof(header),0);

  assign(f,fn); reset(f,1);
  blockread(f,header,sizeof(header));
  close(f);

  fmpt:=0;
  topt:=0;
  intl:='';
  msgid:='';
  pid:='';

  assign(t,fn); reset(t);
  textseek(t,sizeof(header));
  assign(o,'$$$$$$$$.$!$'); rewrite(o);
  repeat
   readln(t,s);
   if copy(s,1,1)<>#1 then writeln(o,s);
   s:=stupcase(s);
   if copy(s,1,length(klINTL))=klINTL then intl:=copy(s,length(klINTL)+1,255);
   if copy(s,1,length(klTOPT))=klTOPT then str2word(copy(s,length(klTOPT)+1,255),topt);
   if copy(s,1,length(klFMPT))=klFMPT then str2word(copy(s,length(klFMPT)+1,255),fmpt);
   if copy(s,1,length(klMSGID))=klMSGID then msgid:=copy(s,length(klMSGID)+1,255);
   if copy(s,1,length(klPID))=klPID then pid:=copy(s,length(klPID)+1,255);
  until eof(t);
  close(t); close(o);

  if (intl='') and (msgid<>'') then
   begin
    s:=ExtractWord(1,msgid,[' ']);
    INTL:=S+' '+S;
    Str2Word(ExtractWord(2,S,[':','/','.']),Header.OrigNet);
    Str2Word(ExtractWord(3,S,[':','/','.']),Header.OrigNode);
    S:=ExtractWord(4,S,[':','/','.']);
    if S='' then fmpt:=0 else str2word(s,fmpt);
   end;

  assign(f,'$$$$$$$$.$!$'); reset(f,1);
  messagesize:=filesize(f);
  getmem(message,messagesize);
  blockread(f,message^,messagesize);
  close(f);
  erase(f);
 end;

procedure TMessage.SaveMsg;
 var
  f: file;
  t: text;
 begin
  {$I-}
  assign(f,fn); rewrite(f,1); if ioresult<>0 then exit;
  blockwrite(f,header,sizeof(header));
  close(f);

  assign(T,fn); append(t);
  writeln(t,klINTL, INTL);
  writeln(t,klMSGID, MSGID);
  writeln(t,klPID, PID);
  writeln(t,klFMPT, fmpt);
  writeln(T,klTOPT, topt);
  close(t);

  assign(f,fn); reset(f,1);
  seek(f,filesize(f));
  blockwrite(f,message^,messagesize);
  close(f);
 end;

destructor TMessage.Done;
 begin
  inherited done;
  if message<>nil then
  freemem(message,messagesize);
  asm
   jmp @quit
   db '.MSG processing unit version 1.0 [RPC]',0Dh,0Ah
   db '(c) by WiZARD, 1997.',0Dh,0Ah
   db '2:5031/27 183:5031/9 911:1959/1',0Dh,0Ah
   db 'Thx to Selen.',0Dh,0Ah
@quit:
  end;
 end;

end.